#
# $Id: config.rb,v 1.25 2004/03/28 10:52:59 aamine Exp $
#
# Copyright (C) 2003,2004 Minero Aoki
#
# This program is free software.
# You can distribute/modify this program under the terms of
# the GNU LGPL, Lesser General Public License version 2.1.
#

module BitChannel

  FRONT_PAGE_NAME = 'FrontPage'
  HELP_PAGE_NAME = 'HelpPage'
  TMP_PAGE_NAME = 'tmp'

  class Config
    def initialize(args)
      args = args.dup
      def args.getopt(name)
        raise ConfigError, "Config Error: not set: config.#{name}" \
            unless key?(name)
        delete(name).untaint
      end
      def args.fetchopt(name, default)
        return default unless key?(name)
        delete(name).untaint
      end

      @templatedir = args.getopt(:templatedir)
      @charset     = args.getopt(:charset)
      @css_url     = args.getopt(:css_url)
      @html_url_p  = args.getopt(:use_html_url)
      @site_name   = args.fetchopt(:site_name, nil)
      @logo_url    = args.fetchopt(:logo_url, nil)
      args.each do |key, val|
        raise ConfigError, "Config Error: unknown key: config.#{key}"
      end
    end

    attr_reader :templatedir
    attr_reader :charset
    attr_reader :css_url
    attr_reader :logo_url

    def html_url?
      @html_url_p
    end

    def cgi_url
      File.basename(program_name())
    end

    def program_name
      return $0 if $0
      return ::Apache.request.filename if defined?(::Apache)
      caller(0).last.split(':')[0]
    end

    def site_name
      @site_name || FRONT_PAGE_NAME
    end
  end

end
